net.sf.saxon.expr

## Interface StaticContext

- All Known Subinterfaces:
    XPathStaticContext, XSLTStaticContext
  All Known Implementing Classes:
    AbstractStaticContext, DedicatedStaticContext, ExpressionContext, IndependentContext, JAXPXPathStaticContext, QueryLibrary, QueryLibraryImpl, QueryModule, SchemaElement.XPathStaticContext, TextValueTemplateContext, UseWhenStaticContext

      public interface StaticContext

  A StaticContext contains the information needed while an expression or pattern is being parsed. The information is also sometimes needed at run-time.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Expression` | `bindVariable(StructuredQName qName)` Bind a variable used in this element to the XSLVariable element in which it is declared
    `String` | `getBaseURI()` Get the Base URI of the stylesheet element, for resolving any relative URI's used in the expression.
    `StringCollator` | `getCollation(String name)` Get a named collation.
    `Configuration` | `getConfiguration()` Get the system configuration
    `DecimalFormatManager` | `getDecimalFormatManager()` Get a DecimalFormatManager to resolve the names of decimal formats used in calls to the format-number() function.
    `String` | `getDefaultCollationName()` Get the name of the default collation.
    `String` | `getDefaultElementNamespace()` Get the default XPath namespace for elements and types
    `String` | `getDefaultFunctionNamespace()` Get the default function namespace
    `FunctionLibrary` | `getFunctionLibrary()` Get the function library containing all the in-scope functions available in this static context
    `Set<String>` | `getImportedSchemaNamespaces()` Get the set of imported schemas
    `int` | `getLineNumber()` Get the line number of the expression within its containing entity Returns -1 if no line number is available
    `LocationMap` | `getLocationMap()` Get the location map.
    `NamePool` | `getNamePool()` Get the NamePool used for compiling expressions
    `NamespaceResolver` | `getNamespaceResolver()` Get a namespace resolver to resolve the namespaces declared in this static context.
    `ItemType` | `getRequiredContextItemType()` Get the required type of the context item.
    `String` | `getSystemId()` Get the System ID of the container of the expression.
    `String` | `getURIForPrefix(String prefix)` Get the URI for a namespace prefix.
    `DecimalValue` | `getXPathLanguageLevel()` Get the XPath language level supported, as a decimal value.
    `boolean` | `isAllowedBuiltInType(BuiltInAtomicType type)` Ask whether a built-in type is available in this context.
    `boolean` | `isImportedSchema(String namespace)` Ask whether a Schema for a given target namespace has been imported.
    `boolean` | `isInBackwardsCompatibleMode()` Determine whether backwards compatibility mode is used
    `boolean` | `isSchemaAware()` Ask whether expressions compiled under this static context are schema-aware.
    `void` | `issueWarning(String message, SourceLocator locator)` Issue a compile-time warning.
    `XPathContext` | `makeEarlyEvaluationContext()` Construct a dynamic context for early evaluation of constant subexpressions.

- - ### Method Detail

    - #### getConfiguration

          Configuration getConfiguration()

      Get the system configuration
      Returns:
        the Saxon configuration

    - #### isSchemaAware

          boolean isSchemaAware()

      Ask whether expressions compiled under this static context are schema-aware. They must be schema-aware if the expression is to handle typed (validated) nodes
      Returns:
        true if expressions are schema-aware

    - #### makeEarlyEvaluationContext

          XPathContext makeEarlyEvaluationContext()

      Construct a dynamic context for early evaluation of constant subexpressions.
      Returns:
        a newly constructed dynamic context

    - #### getLocationMap

          LocationMap getLocationMap()

      Get the location map. This is a mapping from short location ids held with each expression or subexpression, to a fully-resolved location in a source stylesheet or query.
      Returns:
        the location map

    - #### issueWarning

          void issueWarning(String message,
                          SourceLocator locator)

      Issue a compile-time warning.
      Parameters:
        `message` - The warning message. This should not contain any prefix such as "Warning".
        `locator` - the location of the construct in question. May be null.

    - #### getSystemId

          String getSystemId()

      Get the System ID of the container of the expression. This is the containing entity (file) and is therefore useful for diagnostics. Use getBaseURI() to get the base URI, which may be different.
      Returns:
        the system ID

    - #### getLineNumber

          int getLineNumber()

      Get the line number of the expression within its containing entity Returns -1 if no line number is available
      Returns:
        the line number, or -1 if not available

    - #### getBaseURI

          String getBaseURI()

      Get the Base URI of the stylesheet element, for resolving any relative URI's used in the expression. Used by the document(), doc(), resolve-uri(), and base-uri() functions. May return null if the base URI is not known.
      Returns:
        the static base URI, or null if not known

    - #### getURIForPrefix

          String getURIForPrefix(String prefix)
                                 throws XPathException

      Get the URI for a namespace prefix. The default namespace is NOT used when the prefix is empty.
      Parameters:
        `prefix` - The namespace prefix.
      Returns:
        the corresponding namespace URI
      Throws:
        `XPathException` - if the prefix is not declared; the associated error code should be XPST0081

    - #### getNamePool

          NamePool getNamePool()

      Get the NamePool used for compiling expressions
      Returns:
        the name pool

    - #### bindVariable

          Expression bindVariable(StructuredQName qName)
                                  throws XPathException

      Bind a variable used in this element to the XSLVariable element in which it is declared
      Parameters:
        `qName` - The name of the variable
      Returns:
        an expression representing the variable reference, This will often be a `VariableReference`, suitably initialized to refer to the corresponding variable declaration, but in general it can be any expression which returns the variable's value when evaluated.
      Throws:
        `XPathException`

    - #### getFunctionLibrary

          FunctionLibrary getFunctionLibrary()

      Get the function library containing all the in-scope functions available in this static context
      Returns:
        the function library

    - #### getCollation

          StringCollator getCollation(String name)

      Get a named collation.
      Parameters:
        `name` - The name of the required collation. Supply null to get the default collation.
      Returns:
        the collation; or null if the required collation is not found.

    - #### getDefaultCollationName

          String getDefaultCollationName()

      Get the name of the default collation.
      Returns:
        the name of the default collation; or the name of the codepoint collation if no default collation has been defined

    - #### getDefaultElementNamespace

          String getDefaultElementNamespace()

      Get the default XPath namespace for elements and types
      Returns:
        the default namespace, or NamespaceConstant.NULL for the non-namespace

    - #### getDefaultFunctionNamespace

          String getDefaultFunctionNamespace()

      Get the default function namespace
      Returns:
        the default namespace for function names

    - #### isInBackwardsCompatibleMode

          boolean isInBackwardsCompatibleMode()

      Determine whether backwards compatibility mode is used
      Returns:
        true if 1.0 compaibility mode is in force.

    - #### isImportedSchema

          boolean isImportedSchema(String namespace)

      Ask whether a Schema for a given target namespace has been imported. Note that the in-scope element declarations, attribute declarations and schema types are the types registered with the (schema-aware) configuration, provided that their namespace URI is registered in the static context as being an imported schema namespace. (A consequence of this is that within a Configuration, there can only be one schema for any given namespace, including the null namespace).
      Parameters:
        `namespace` - the target namespace in question
      Returns:
        true if the given namespace has been imported

    - #### getImportedSchemaNamespaces

          Set<String> getImportedSchemaNamespaces()

      Get the set of imported schemas
      Returns:
        a Set, the set of URIs representing the target namespaces of imported schemas, using the zero-length string to denote the "null" namespace.

    - #### isAllowedBuiltInType

          boolean isAllowedBuiltInType(BuiltInAtomicType type)

      Ask whether a built-in type is available in this context. This method caters for differences between host languages as to which set of types are built in.
      Parameters:
        `type` - the supposedly built-in type. This will always be a type in the XS namespace.
      Returns:
        true if this type can be used in this static context

    - #### getNamespaceResolver

          NamespaceResolver getNamespaceResolver()

      Get a namespace resolver to resolve the namespaces declared in this static context.
      Returns:
        a namespace resolver.

    - #### getRequiredContextItemType

          ItemType getRequiredContextItemType()

      Get the required type of the context item. If no type has been explicitly declared for the context item, an instance of AnyItemType (representing the type item()) is returned.
      Returns:
        the required type of the context item
      Since:
        9.3

    - #### getDecimalFormatManager

          DecimalFormatManager getDecimalFormatManager()

      Get a DecimalFormatManager to resolve the names of decimal formats used in calls to the format-number() function.
      Returns:
        the decimal format manager for this static context, or null if no named decimal formats are available in this environment.
      Since:
        9.2

    - #### getXPathLanguageLevel

          DecimalValue getXPathLanguageLevel()

      Get the XPath language level supported, as a decimal value. The current levels supported are 2.0, and 3.0. The default is 2.0. If running XQuery 1.0, the value is 2.0; if running XQuery 3.0, it is 3.0.
      Returns:
        the XPath language level; the return value will be either `DecimalValue.TWO` or `DecimalValue.THREE`
      Since:
        9.3

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.